"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Auth = exports.useAuth = exports.AuthContext = void 0;
const react_1 = __importStar(require("react"));
const DefaultLoadingScreen_1 = __importDefault(require("./components/DefaultLoadingScreen"));
const DefaultAuthContext = {
    state: {
        isLoading: false,
        isSignedIn: false,
        userData: null
    },
    dispatch: () => { },
    signOut: () => { },
    signIn: () => { },
    isLoaded: () => { },
    isLoading: () => { },
};
exports.AuthContext = (0, react_1.createContext)(DefaultAuthContext);
function useAuth() {
    return (0, react_1.useContext)(exports.AuthContext);
}
exports.useAuth = useAuth;
function reducer(prevState, action) {
    switch (action.type) {
        case "SIGN_IN":
            return Object.assign(Object.assign({}, prevState), { isSignedIn: true, isLoading: false, userData: action.userData });
        case "SIGN_OUT":
            return Object.assign(Object.assign({}, prevState), { isSignedIn: false, isLoading: false, userData: null });
        case "LOADED":
            return Object.assign(Object.assign({}, prevState), { isLoading: false });
        case "IS_LOADING":
            return Object.assign(Object.assign({}, prevState), { isLoading: true });
        default:
            return Object.assign({}, prevState);
    }
}
function Auth({ AutoLoginComponent, AfterSignInComponent, BeforeSignInComponent, autoLogin, LoadingScreen = react_1.default.createElement(DefaultLoadingScreen_1.default, null), isLoadingInitially = false, splashScreenTime = 3000 }) {
    const intialstate = {
        isLoading: isLoadingInitially,
        isSignedIn: false,
        userData: null
    };
    const [state, dispatch] = (0, react_1.useReducer)(reducer, intialstate);
    const signIn = (userData) => {
        dispatch({ type: "SIGN_IN", userData: userData });
    };
    const signOut = () => {
        dispatch({ type: "SIGN_OUT" });
    };
    const isLoaded = () => {
        dispatch({ type: "LOADED" });
    };
    const isLoading = () => {
        dispatch({ type: "IS_LOADING" });
    };
    (0, react_1.useEffect)(() => {
        setTimeout(isLoaded, splashScreenTime);
    }, []);
    return state.isLoading ? (react_1.default.createElement(react_1.default.Fragment, null, LoadingScreen)) : (react_1.default.createElement(exports.AuthContext.Provider, { value: { state, dispatch, signOut, signIn, isLoaded, isLoading } },
        react_1.default.createElement(react_1.default.Fragment, null,
            autoLogin && AutoLoginComponent,
            state.isSignedIn ? react_1.default.createElement(react_1.default.Fragment, null, AfterSignInComponent) : react_1.default.createElement(react_1.default.Fragment, null, BeforeSignInComponent))));
}
exports.Auth = Auth;
//# sourceMappingURL=Auth.js.map