import React from "react";
import { Controller, useFormContext } from "react-hook-form";
import { DBDateFormat, dbDateToVisual } from "./utils/dBDateToVisual";
import { dateDisplayNewFormat } from "./utils/dateConverterNew";
const transferAsIDate = {
    output: (value) => {
        return { display: value, database: value };
    },
    outputOnBlur: (value) => {
        return dateDisplayNewFormat(value);
    },
    input: (value) => {
        return value.dispDate;
    }
};
const transferAsString = {
    output: (value) => {
        if (!DBDateFormat.test(value))
            return value;
        else
            return dateDisplayNewFormat(value).dataDate;
    },
    outputOnBlur: (value) => {
        return dateDisplayNewFormat(value).dataDate;
    },
    input: (value) => {
        return dbDateToVisual(value);
    }
};
export const DateInput = ({ placeHolder, name, maxDate, minDate, defaultValue, format = 'DB' }) => {
    const formContext = useFormContext();
    const transferMethods = format === 'DB' ? transferAsString : transferAsIDate;
    const myval = formContext.watch(name);
    console.log(myval);
    return (React.createElement(React.Fragment, null,
        placeHolder,
        React.createElement(Controller, { name: name, control: formContext.control, rules: {
                max: maxDate,
                min: minDate
            }, defaultValue: defaultValue, render: ({ field }) => (React.createElement("input", Object.assign({ type: "text" }, field, { value: field.value ? transferMethods.input(field.value) : "", onChange: e => {
                    field.onChange(transferMethods.output(e.target.value));
                }, onBlur: e => field.onChange(transferMethods.outputOnBlur(e.target.value)) }))) })));
};
//# sourceMappingURL=DateInput.js.map